[serial] use hw flow control if supported

Bug #1328295 reported by dann frazier on 2014-06-09
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Unassigned
Trusty
Medium
Unassigned

Bug Description

HP Moonshot cartridges support hardware flow control, but right now only software assisted hw flow control is supported. This patch from upstream enables this functionality when exposed by firmware:

commit 06aa82e498c144c7784a6f3d3b55458b272d6146
Author: Murali Karicheri <email address hidden>
Date: Thu May 1 15:04:53 2014 -0400

    serial: uart: add hw flow control support configuration

    8250 uart driver currently supports only software assisted hw flow
    control. The software assisted hw flow control maintains a hw_stopped
    flag in the tty structure to stop and start transmission and use modem
    status interrupt for the event to drive the handshake signals. This is
    not needed if hw has flow control capabilities. This patch adds a
    DT attribute for enabling hw flow control for a uart port. Also skip
    stop and start if this flag is present in flag field of the port
    structure.

    Signed-off-by: Murali Karicheri <email address hidden>
    CC: Rob Herring <email address hidden>
    CC: Pawel Moll <email address hidden>
    CC: Mark Rutland <email address hidden>
    CC: Ian Campbell <email address hidden>
    CC: Kumar Gala <email address hidden>
    CC: Randy Dunlap <email address hidden>
    CC: Jiri Slaby <email address hidden>
    CC: Santosh Shilimkar <email address hidden>
    Signed-off-by: Greg Kroah-Hartman <email address hidden>

This bug is missing log files that will aid in diagnosing the problem. From a terminal window please run:

apport-collect 1328295

and then change the status of the bug to 'Confirmed'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
dann frazier (dannf) wrote :

Marking confirmed; logs are unlikely to help with this issue.

Changed in linux (Ubuntu):
status: Incomplete → Confirmed
Changed in linux (Ubuntu):
importance: Undecided → Medium
status: Confirmed → Triaged
tags: added: kernel-da-key
Joseph Salisbury (jsalisbury) wrote :

Dann, Utopic will pick up commit 06aa82e automatically when it is re-based. Are you requesting this commit be included in any of the current stable releases?

Joseph Salisbury (jsalisbury) wrote :

Also, do you have a way to test if I build a Trusty test kernel with this patch applied?

On Thu, Jun 12, 2014 at 11:31 AM, Joseph Salisbury
<email address hidden> wrote:
> Also, do you have a way to test if I build a Trusty test kernel with
> this patch applied?

Yes, though I've already done my own build/test.

dann frazier (dannf) wrote :

On Thu, Jun 12, 2014 at 11:29 AM, Joseph Salisbury
<email address hidden> wrote:
> Dann, Utopic will pick up commit 06aa82e automatically when it is re-
> based. Are you requesting this commit be included in any of the current
> stable releases?

Just trusty.

Joseph Salisbury (jsalisbury) wrote :

Just to confirm this commit fixes this bug, I built a Trusty test kernel, which can be downloaded from:
http://kernel.ubuntu.com/~jsalisbury/lp1328295/

Can you test this kernel to confirm it fixes this bug? If it does, we can submit an SRU request to the kernel-team mailing list to have the commit included in Trusty.

Changed in linux (Ubuntu Trusty):
status: New → In Progress
importance: Undecided → Medium
assignee: nobody → Joseph Salisbury (jsalisbury)
dann frazier (dannf) wrote :

On Fri, Jun 13, 2014 at 3:28 PM, Joseph Salisbury
<email address hidden> wrote:
> Just to confirm this commit fixes this bug, I built a Trusty test kernel, which can be downloaded from:
> http://kernel.ubuntu.com/~jsalisbury/lp1328295/
>
> Can you test this kernel to confirm it fixes this bug?

My target platform is arm64 - if you can provide arm64 binaries, or
the source, I could test it. Though, I have already tested a trusty
kernel with this cherry-pick on the target platform.

> If it does, we
> can submit an SRU request to the kernel-team mailing list to have the
> commit included in Trusty.

This commit is already in the master-next branch for trusty:
http://kernel.ubuntu.com/git?p=ubuntu/ubuntu-trusty.git;a=commit;h=3545bd96109d76abb535f2751cb7162bc519a11a

Based on this request:
https://lists.ubuntu.com/archives/kernel-team/2014-June/043580.html

Does that imply we're good?

Joseph Salisbury (jsalisbury) wrote :

Yes, the fix is committed.

Changed in linux (Ubuntu Trusty):
status: In Progress → Fix Committed
assignee: Joseph Salisbury (jsalisbury) → nobody
Changed in linux (Ubuntu):
status: Triaged → Fix Committed
Luis Henriques (henrix) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-trusty' to 'verification-done-trusty'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-trusty
dann frazier (dannf) on 2014-07-10
tags: added: verification-done-trusty
removed: verification-needed-trusty
Launchpad Janitor (janitor) wrote :
Download full text (35.8 KiB)

This bug was fixed in the package linux - 3.13.0-32.57

---------------
linux (3.13.0-32.57) trusty; urgency=low

  [ Upstream Kernel Changes ]

  * l2tp: Privilege escalation in ppp over l2tp sockets
    - LP: #1341472
    - CVE-2014-4943

linux (3.13.0-32.56) trusty; urgency=low

  [ Luis Henriques ]

  * Merged back Ubuntu-3.13.0-30.55 security release
  * Revert "x86_64,ptrace: Enforce RIP <= TASK_SIZE_MAX (CVE-2014-4699)"
    - LP: #1337339
  * Release Tracking Bug
    - LP: #1338524

  [ Upstream Kernel Changes ]

  * ptrace,x86: force IRET path after a ptrace_stop()
    - LP: #1337339
    - CVE-2014-4699
  * hpsa: add new Smart Array PCI IDs (May 2014)
    - LP: #1337516

linux (3.13.0-31.55) trusty; urgency=low

  [ Luis Henriques ]

  * Release Tracking Bug
    - LP: #1336278

  [ Andy Whitcroft ]

  * [Config] switch hyper-keyboard to virtual
    - LP: #1325306
  * [Packaging] linux-udeb-flavour -- standardise on linux prefix

  [ dann frazier ]

  * [Config] CONFIG_GPIO_DWAPB=m
    - LP: #1334823

  [ Feng Kan ]

  * SAUCE: (no-up) arm64: dts: Add Designware GPIO dts binding to APM
    X-Gene platform
    - LP: #1334823

  [ John Johansen ]

  * SAUCE: (no-up) apparmor: fix apparmor spams log with warning message
    - LP: #1308761

  [ Kamal Mostafa ]

  * [Config] updateconfigs ACPI_PROCFS_POWER=y after v3.13.11.4 rebase

  [ Loc Ho ]

  * SAUCE: (no-up) phy-xgene: Use correct tuning for Mustang
    - LP: #1335636

  [ Michael Ellerman ]

  * SAUCE: (no-up) powerpc/perf: Ensure all EBB register state is cleared
    on fork()
    - LP: #1328914

  [ Ming Lei ]

  * Revert "SAUCE: (no-up) rtc: Add X-Gene SoC Real Time Clock Driver"
    - LP: #1274305

  [ Suman Tripathi ]

  * SAUCE: (no-up) libahci: Implement the function ahci_restart_engine to
    restart the port dma engine.
    - LP: #1335645
  * SAUCE: (no-up) ata: Fix the dma state machine lockup for the IDENTIFY
    DEVICE PIO mode command.
    - LP: #1335645

  [ Tim Gardner ]

  * [Config] CONFIG_POWERNV_CPUFREQ=y for powerpc, ppc64el
    - LP: #1324571
  * [Debian] Add UTS_UBUNTU_RELEASE_ABI to utsrelease.h
    - LP: #1327619
  * [Config] CONFIG_HAVE_MEMORYLESS_NODES=y
    - LP: #1332063
  * [Config] CONFIG_HID_RMI=m
    - LP: #1305522

  [ Upstream Kernel Changes ]

  * Revert "offb: Add palette hack for little endian"
    - LP: #1333430
  * Revert "net: mvneta: fix usage as a module on RGMII configurations"
    - LP: #1333837
  * Revert "USB: serial: add usbid for dell wwan card to sierra.c"
    - LP: #1333837
  * Revert "macvlan : fix checksums error when we are in bridge mode"
    - LP: #1333838
  * serial: uart: add hw flow control support configuration
    - LP: #1328295
  * mm/numa: Remove BUG_ON() in __handle_mm_fault()
    - LP: #1323165
  * Tools: hv: Handle the case when the target file exists correctly
    - LP: #1306215
  * Documentation/devicetree/bindings: add documentation for the APM X-Gene
    SoC RTC DTS binding
    - LP: #1274305
  * drivers/rtc: add APM X-Gene SoC RTC driver
    - LP: #1274305
  * arm64: add APM X-Gene SoC RTC DTS entry
    - LP: #1274305
  * powerpc/perf: Add Power8 cache & TLB events
    - LP: #1328914
  * powerpc/perf: Configure BH...

Changed in linux (Ubuntu Trusty):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers